import Qt 4.7

Item {
	id: wrapper

	property string flag: ""
	property string name: ""
	property string desc: ""
	property int spacing: 10

	signal flagClicked

	Row {
		id: caption
		anchors.left: parent.left; anchors.top: parent.top
		width: parent.width; height: width/4/fi; spacing: wrapper.spacing

		Image {
			id: flagImage
			width: parent.width/4; height: width/fi
			source: wrapper.flag; smooth: true
			MouseArea { anchors.fill: parent; onClicked: flagClicked() }
		}

		Text {
			text: wrapper.name;
			width: parent.width - flagImage.width - spacing
			height: flagImage.height
			horizontalAlignment: "AlignHCenter"
			verticalAlignment: "AlignVCenter"
			color: "white"; styleColor: "black"; style: Text.Raised
			font { bold: true; pixelSize: 24 }
		}
	}

	Flickable {
		anchors.left: parent.left; anchors.top: caption.bottom
		anchors.right: parent.right; anchors.bottom: parent.bottom
		anchors.topMargin: spacing

		flickableDirection: "VerticalFlick"
		contentWidth: width; contentHeight: height; clip: true

		Text {
			id: text
			text: wrapper.desc; width: parent.width; height: parent.height

			color: "white"; styleColor: "black"; style: Text.Raised
			verticalAlignment: "AlignVCenter"
			horizontalAlignment: "AlignHCenter"
			wrapMode: Text.WordWrap
		}
	}
	Keys.onPressed: {
		if (event.key == Qt.Key_Return) {
			event.accepted = true
			flagClicked();
		}
	}
}
