import Qt 4.7

Item {
	id: wrapper

	property alias viewFocus: view.focus

	property string resDir: "qrc:res/" // resource directory
	property int spacing: 10        // spacing between items
	property int ipl: 3             // items per line

	signal flagClicked

	XmlListModel {
		id: model
		source: resDir + "Flags.xml"
		query: "/countries/country"

		XmlRole { name: "name"; query: "@name/string()" }
		XmlRole { name: "image"; query: "@flag/string()" }
		XmlRole { name: "desc"; query: "description/string()" }
	}

	Component { id: delegate; Item {
		id: wrapper
		function setDeatils() {
			details.flag = resDir + image
			details.name = name
			details.desc = desc
		}
		Rectangle {
			id: frame; anchors.fill: flagImage; radius: 5; smooth: true
			color: wrapper.activeFocus ? "white" : "transparent"; scale: 1.15
		}
		Image {
			id: flagImage
			source: resDir + image; smooth: true; opacity: 0.5

			x: 0; y: 0
			width: GridView.view.cellWidth - spacing
			height: GridView.view.cellHeight - spacing

			MouseArea {
				id: mouseArea; anchors.fill: parent; hoverEnabled: true
				onClicked: {
					GridView.view.currentIndex = index
					setDeatils()
					flagClicked()
					wrapper.forceActiveFocus()
				}
			}
		}
		Keys.onPressed: {
			if (event.key == Qt.Key_Return) {
				GridView.view.currentIndex = index
				setDeatils()
				flagClicked()
			}
			else if (event.key == Qt.Key_Escape) Qt.quit()
		}
		states: [
			State {
				name: "active"; when: wrapper.activeFocus == true
				PropertyChanges { target: flagImage; scale: 1.1; opacity: 1.0 }
			},
			State {
				name: "hovered"; when: mouseArea.containsMouse
				PropertyChanges { target: flagImage; opacity: 1.0 }
			}
		]
		transitions: Transition {
			NumberAnimation { properties: "scale, opacity"; duration: 100 }
		}
	}}

	GridView {
		id: view
		anchors.fill: parent; focus: true
		cellWidth: width/ipl - 1; cellHeight: cellWidth/fi

		model: model; delegate: delegate
	}
}
