import Qt 4.7

Rectangle {
	property real fi: (1 + Math.sqrt(5)) / 2  // golden ratio
	property int margin: 10

	width: 400; height: width/fi; radius: 10; color: "#20000000"

	Flipable {
		id: flipable; anchors.fill: parent

		property int angle: 0

		front: FlagGrid {
			id: flagGrid
			x: margin; y: margin
			width: parent.width - margin; height: parent.height - margin
			onFlagClicked: { flipable.state = "details"; details.focus = true }
		}
		back: Details {
			id: details
			x: margin; y: margin
			width: parent.width - 2*margin; height: parent.height - 2*margin
			onFlagClicked: { flipable.state = ""; flagGrid.viewFocus = true }
		}
		transform: Rotation {
			origin.x: flipable.width/2; origin.y: flipable.height/2
			axis.x: 0; axis.y: 1; axis.z: 0     // rotate around y-axis
			angle: flipable.angle
		}
		states: State {
			name: "details"
			PropertyChanges { target: flipable; angle: 180 }
		}
		transitions: Transition {
			NumberAnimation {
				properties: "angle"; duration: 700
				easing.type: Easing.OutExpo
			}
		}
	}
}
